/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define PHOTO_LEVEL_ON  (200)
#define PHOTO_LEVEL_OFF (2000)

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
static const char msg1[] = {"russian warship go fuck yourself!\nfeel free to contact shilvn@gmail.com"};
volatile flag_t Flag = {0};
volatile uint32_t photo_Value;

/* Private function prototypes -----------------------------------------------*/
static void servo_open(void);
static void servo_close(void);

/* Private user code ---------------------------------------------------------*/

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* Initialize onBoard Hardware */
  Board_Init();

  delay_ms(500);
  servo_open();
  delay_ms(1000);
  servo_close();
  delay_ms(1000);

  if ((Select_Port->IDR & Select_Pin) == 0) {
    Flag.ONE_CHANNEL = 1;
  } else {
    Flag.ONE_CHANNEL = 0;
  }

  /* if light is on, wait for off */
  while (photo_Value <= PHOTO_LEVEL_OFF) {
    //IWDG->KR = 0xAAAA;
    __WFI();
  }

  /* Infinite loop */
  while (1)
  {
    /* wait for light on */
    while (photo_Value > PHOTO_LEVEL_ON) {
      //IWDG->KR = 0xAAAA;
      __WFI();
    }
    /* open servo 1 */
    Servo_1_CHNL = SERVO_OPEN_VAL;
    /* wait for light off */
    while (photo_Value <= PHOTO_LEVEL_OFF) {
      //IWDG->KR = 0xAAAA;
      __WFI();
    }
    /* close servo 1 */
    Servo_1_CHNL = SERVO_INIT_VAL;
    
    if (Flag.ONE_CHANNEL != 0) {
      /* wait for light on */
      while (photo_Value > PHOTO_LEVEL_ON) {
        //IWDG->KR = 0xAAAA;
        __WFI();
      }
      Servo_2_CHNL = SERVO_OPEN_VAL;
      /* wait for light off */
      while (photo_Value <= PHOTO_LEVEL_OFF) {
        //IWDG->KR = 0xAAAA;
        __WFI();
      }
      /* close servo 2 */
      Servo_2_CHNL = SERVO_INIT_VAL;
    }

    /* end of life */
    //while (1) {
    //  __WFI();
    //}
  }
} /* End of mine() */

static void servo_open(void) {
  int i;
  for (i=SERVO_INIT_VAL; i <= SERVO_OPEN_VAL; i+=50) {
    Servo_1_CHNL = i;
    Servo_2_CHNL = i;
    delay_ms(40);
  }
}

static void servo_close(void) {
  int i;
  for (i=SERVO_OPEN_VAL; i >= SERVO_INIT_VAL; i-=50) {
    Servo_1_CHNL = i;
    Servo_2_CHNL = i;
    delay_ms(40);
  }
}

/*
static void uart_init(uint32_t baud)
{
  GPIO_SetPinMode(GPIOB, GPIO_PIN_6, GPIO_MODE_AFF);

  RCC->APBENR2 |= RCC_APBENR2_USART1EN;

  USART1->CR1 = USART_CR1_RE | USART_CR1_TE | USART_CR1_FIFOEN;
  USART1->BRR = (SystemCoreClock / baud);
  USART1->CR1 |= USART_CR1_UE;
}

static void uart_putc(char c)
{
  while (0 == (USART1->ISR & USART_ISR_TXE_TXFNF));
  USART1->TDR = c;
}

static void uart_puts(char *s)
{
  while (*s)
    uart_putc(*s++);
}
*/

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
